/* THIS FILE WAS AUTOMATICALLY GENERATED.  DO NOT MODIFY! */
/* generated from the file: example.scm */

#include <stdlib.h>
#include <stdio.h>
#include <ctl-io.h>

/******* Input variables *******/
integer         dimensions;
material_type   default_material;
lattice         geometry_lattice;
geometric_object_list geometry;
boolean         ensure_periodicity;
vector3_list    k_points;
cvector3        dummy;

/******* Output variables *******/
cvector3        dummy;
number          mean_dielectric;
number_list     gaps;

int             num_read_input_vars = 0;	/* # calls to read_input_vars */
int             num_write_output_vars = 0;	/* # calls to read_input_vars */

/******* class input functions *******/

void 
lattice_input(SCM so, lattice * o)
{
	o->basis1 = vector3_object_property(so, "basis1");
	o->basis2 = vector3_object_property(so, "basis2");
	o->basis3 = vector3_object_property(so, "basis3");
	o->size = vector3_object_property(so, "size");
	o->basis_size = vector3_object_property(so, "basis-size");
	o->b1 = vector3_object_property(so, "b1");
	o->b2 = vector3_object_property(so, "b2");
	o->b3 = vector3_object_property(so, "b3");
	o->basis = matrix3x3_object_property(so, "basis");
	o->metric = matrix3x3_object_property(so, "metric");
}

void 
ellipsoid_input(SCM so, ellipsoid * o)
{
	o->inverse_semi_axes = vector3_object_property(so, "inverse-semi-axes");
}

void 
block_input(SCM so, block * o)
{
	o->e1 = vector3_object_property(so, "e1");
	o->e2 = vector3_object_property(so, "e2");
	o->e3 = vector3_object_property(so, "e3");
	o->size = vector3_object_property(so, "size");
	o->projection_matrix = matrix3x3_object_property(so, "projection-matrix");
	if (object_is_member("ellipsoid", so)) {
		o->which_subclass = ELLIPSOID;
		o->subclass.ellipsoid_data = (ellipsoid *) malloc(sizeof(ellipsoid));
		ellipsoid_input(so, o->subclass.ellipsoid_data);
	} else
		o->which_subclass = BLOCK_SELF;
}

void 
sphere_input(SCM so, sphere * o)
{
	o->radius = number_object_property(so, "radius");
}

void 
cone_input(SCM so, cone * o)
{
	o->radius2 = number_object_property(so, "radius2");
}

void 
cylinder_input(SCM so, cylinder * o)
{
	o->axis = vector3_object_property(so, "axis");
	o->radius = number_object_property(so, "radius");
	o->height = number_object_property(so, "height");
	if (object_is_member("cone", so)) {
		o->which_subclass = CONE;
		o->subclass.cone_data = (cone *) malloc(sizeof(cone));
		cone_input(so, o->subclass.cone_data);
	} else
		o->which_subclass = CYLINDER_SELF;
}

void 
geometric_object_input(SCM so, geometric_object * o)
{
	material_type_input(object_object_property(so, "material"), &o->material);
	o->center = vector3_object_property(so, "center");
	if (object_is_member("block", so)) {
		o->which_subclass = BLOCK;
		o->subclass.block_data = (block *) malloc(sizeof(block));
		block_input(so, o->subclass.block_data);
	} else if (object_is_member("sphere", so)) {
		o->which_subclass = SPHERE;
		o->subclass.sphere_data = (sphere *) malloc(sizeof(sphere));
		sphere_input(so, o->subclass.sphere_data);
	} else if (object_is_member("cylinder", so)) {
		o->which_subclass = CYLINDER;
		o->subclass.cylinder_data = (cylinder *) malloc(sizeof(cylinder));
		cylinder_input(so, o->subclass.cylinder_data);
	} else
		o->which_subclass = GEOMETRIC_OBJECT_SELF;
}

void 
material_type_input(SCM so, material_type * o)
{
	o->epsilon = number_object_property(so, "epsilon");
	o->conductivity = number_object_property(so, "conductivity");
}

/******* class destruction functions *******/

void 
lattice_destroy(lattice o)
{
}

void 
ellipsoid_destroy(ellipsoid o)
{
}

void 
block_destroy(block o)
{
	if (o.which_subclass == ELLIPSOID) {
		ellipsoid_destroy(*o.subclass.ellipsoid_data);
		free(o.subclass.ellipsoid_data);
	} else {
	}
}

void 
sphere_destroy(sphere o)
{
}

void 
cone_destroy(cone o)
{
}

void 
cylinder_destroy(cylinder o)
{
	if (o.which_subclass == CONE) {
		cone_destroy(*o.subclass.cone_data);
		free(o.subclass.cone_data);
	} else {
	}
}

void 
geometric_object_destroy(geometric_object o)
{
	material_type_destroy(o.material);
	if (o.which_subclass == BLOCK) {
		block_destroy(*o.subclass.block_data);
		free(o.subclass.block_data);
	} else if (o.which_subclass == SPHERE) {
		sphere_destroy(*o.subclass.sphere_data);
		free(o.subclass.sphere_data);
	} else if (o.which_subclass == CYLINDER) {
		cylinder_destroy(*o.subclass.cylinder_data);
		free(o.subclass.cylinder_data);
	} else {
	}
}

void 
material_type_destroy(material_type o)
{
}

/******* read input variables *******/

SCM 
read_input_vars(void)
{
	if (num_read_input_vars++)
		destroy_input_vars();
	dimensions = ctl_get_integer("dimensions");
	material_type_input(ctl_get_object("default-material"), &default_material);
	lattice_input(ctl_get_object("geometry-lattice"), &geometry_lattice);
	{
		list            lo_t = ctl_get_list("geometry");
		int             i_t;
		geometry.num_items = list_length(lo_t);
		geometry.items = (geometric_object *) malloc(sizeof(geometric_object) * geometry.num_items);
		for (i_t = 0; i_t < geometry.num_items; i_t++) {
			geometric_object_input(object_list_ref(lo_t, i_t), &geometry.items[i_t]);
		}
	}
	ensure_periodicity = ctl_get_boolean("ensure-periodicity");
	{
		list            lo_t = ctl_get_list("k-points");
		int             i_t;
		k_points.num_items = list_length(lo_t);
		k_points.items = (vector3 *) malloc(sizeof(vector3) * k_points.num_items);
		for (i_t = 0; i_t < k_points.num_items; i_t++) {
			k_points.items[i_t] = vector3_list_ref(lo_t, i_t);
		}
	}
	dummy = ctl_get_cvector3("dummy");
	return SCM_UNSPECIFIED;
}

/******* write output variables *******/

SCM 
write_output_vars(void)
{
	num_write_output_vars++;
	ctl_set_cvector3("dummy", dummy);
	ctl_set_number("mean-dielectric", mean_dielectric);
	ctl_set_list("gaps", make_number_list(gaps.num_items, gaps.items));
	return SCM_UNSPECIFIED;
}

/******* destroy input variables *******/

SCM 
destroy_input_vars(void)
{
	material_type_destroy(default_material);
	lattice_destroy(geometry_lattice);
	{
		int             index_t;
		for (index_t = 0; index_t < geometry.num_items; index_t++) {
			geometric_object_destroy(geometry.items[index_t]);
		}
	}
	free(geometry.items);
	{
		int             index_t;
		for (index_t = 0; index_t < k_points.num_items; index_t++) {
		}
	}
	free(k_points.items);
	return SCM_UNSPECIFIED;
}

/******* destroy output variables *******/

SCM 
destroy_output_vars(void)
{
	{
		int             index_t;
		for (index_t = 0; index_t < gaps.num_items; index_t++) {
		}
	}
	free(gaps.items);
	return SCM_UNSPECIFIED;
}

/******* external-functions *******/

SCM 
function_func_aux(SCM arg_scm_0, SCM arg_scm_1)
{
	SCM             return_val_scm;
	number          return_val_c;
	function        arg_c_0;
	number          arg_c_1;

	arg_c_0 = ctl_convert_function_to_c(arg_scm_0);
	arg_c_1 = ctl_convert_number_to_c(arg_scm_1);

#ifdef HAVE_SCM_FLUSH_ALL_PORTS
	scm_flush_all_ports();
#endif
	return_val_c = function_func(arg_c_0, arg_c_1);

	fflush(stdout);
	fflush(stderr);

	return_val_scm = ctl_convert_number_to_scm(return_val_c);
	return return_val_scm;
}

SCM 
list_func_test_aux(SCM arg_scm_0, SCM arg_scm_1, SCM arg_scm_2)
{
	SCM             return_val_scm;
	vector3_list    return_val_c;
	number          arg_c_0;
	integer_list    arg_c_1;
	vector3         arg_c_2;

	arg_c_0 = ctl_convert_number_to_c(arg_scm_0);
	{
		list            lo_t = ctl_convert_list_to_c(arg_scm_1);
		int             i_t;
		arg_c_1.num_items = list_length(lo_t);
		arg_c_1.items = (integer *) malloc(sizeof(integer) * arg_c_1.num_items);
		for (i_t = 0; i_t < arg_c_1.num_items; i_t++) {
			arg_c_1.items[i_t] = integer_list_ref(lo_t, i_t);
		}
	}
	arg_c_2 = ctl_convert_vector3_to_c(arg_scm_2);

#ifdef HAVE_SCM_FLUSH_ALL_PORTS
	scm_flush_all_ports();
#endif
	return_val_c = list_func_test(arg_c_0, arg_c_1, arg_c_2);

	fflush(stdout);
	fflush(stderr);
	{
		int             index_t;
		for (index_t = 0; index_t < arg_c_1.num_items; index_t++) {
		}
	}
	free(arg_c_1.items);

	return_val_scm = ctl_convert_list_to_scm(make_vector3_list(return_val_c.num_items, return_val_c.items));
	{
		int             index_t;
		for (index_t = 0; index_t < return_val_c.num_items; index_t++) {
		}
	}
	free(return_val_c.items);
	return return_val_scm;
}

SCM 
energy_in_object_aux(SCM arg_scm_0)
{
	SCM             return_val_scm;
	number          return_val_c;
	geometric_object arg_c_0;

	geometric_object_input(ctl_convert_object_to_c(arg_scm_0), &arg_c_0);

#ifdef HAVE_SCM_FLUSH_ALL_PORTS
	scm_flush_all_ports();
#endif
	return_val_c = energy_in_object(arg_c_0);

	fflush(stdout);
	fflush(stderr);
	geometric_object_destroy(arg_c_0);

	return_val_scm = ctl_convert_number_to_scm(return_val_c);
	return return_val_scm;
}

SCM 
run_program_aux(void)
{


#ifdef HAVE_SCM_FLUSH_ALL_PORTS
	scm_flush_all_ports();
#endif
	run_program();

	fflush(stdout);
	fflush(stderr);

	return SCM_UNSPECIFIED;
}

SCM 
square_basis_aux(SCM arg_scm_0, SCM arg_scm_1)
{
	SCM             return_val_scm;
	matrix3x3       return_val_c;
	matrix3x3       arg_c_0;
	vector3         arg_c_1;

	arg_c_0 = ctl_convert_matrix3x3_to_c(arg_scm_0);
	arg_c_1 = ctl_convert_vector3_to_c(arg_scm_1);

#ifdef HAVE_SCM_FLUSH_ALL_PORTS
	scm_flush_all_ports();
#endif
	return_val_c = square_basis(arg_c_0, arg_c_1);

	fflush(stdout);
	fflush(stderr);

	return_val_scm = ctl_convert_matrix3x3_to_scm(return_val_c);
	return return_val_scm;
}

SCM 
display_geometric_object_info_aux(SCM arg_scm_0, SCM arg_scm_1)
{
	integer         arg_c_0;
	geometric_object arg_c_1;

	arg_c_0 = ctl_convert_integer_to_c(arg_scm_0);
	geometric_object_input(ctl_convert_object_to_c(arg_scm_1), &arg_c_1);

#ifdef HAVE_SCM_FLUSH_ALL_PORTS
	scm_flush_all_ports();
#endif
	display_geometric_object_info(arg_c_0, arg_c_1);

	fflush(stdout);
	fflush(stderr);
	geometric_object_destroy(arg_c_1);

	return SCM_UNSPECIFIED;
}

SCM 
point_in_periodic_objectp_aux(SCM arg_scm_0, SCM arg_scm_1)
{
	SCM             return_val_scm;
	boolean         return_val_c;
	vector3         arg_c_0;
	geometric_object arg_c_1;

	arg_c_0 = ctl_convert_vector3_to_c(arg_scm_0);
	geometric_object_input(ctl_convert_object_to_c(arg_scm_1), &arg_c_1);

#ifdef HAVE_SCM_FLUSH_ALL_PORTS
	scm_flush_all_ports();
#endif
	return_val_c = point_in_periodic_objectp(arg_c_0, arg_c_1);

	fflush(stdout);
	fflush(stderr);
	geometric_object_destroy(arg_c_1);

	return_val_scm = ctl_convert_boolean_to_scm(return_val_c);
	return return_val_scm;
}

SCM 
point_in_objectp_aux(SCM arg_scm_0, SCM arg_scm_1)
{
	SCM             return_val_scm;
	boolean         return_val_c;
	vector3         arg_c_0;
	geometric_object arg_c_1;

	arg_c_0 = ctl_convert_vector3_to_c(arg_scm_0);
	geometric_object_input(ctl_convert_object_to_c(arg_scm_1), &arg_c_1);

#ifdef HAVE_SCM_FLUSH_ALL_PORTS
	scm_flush_all_ports();
#endif
	return_val_c = point_in_objectp(arg_c_0, arg_c_1);

	fflush(stdout);
	fflush(stderr);
	geometric_object_destroy(arg_c_1);

	return_val_scm = ctl_convert_boolean_to_scm(return_val_c);
	return return_val_scm;
}

void 
export_external_functions(void)
{
	gh_new_procedure("function-func-aux", function_func_aux, 2, 0, 0);
	gh_new_procedure("list-func-test-aux", list_func_test_aux, 3, 0, 0);
	gh_new_procedure("energy-in-object-aux", energy_in_object_aux, 1, 0, 0);
	gh_new_procedure("run-program-aux", run_program_aux, 0, 0, 0);
	gh_new_procedure("square-basis-aux", square_basis_aux, 2, 0, 0);
	gh_new_procedure("display-geometric-object-info-aux", display_geometric_object_info_aux, 2, 0, 0);
	gh_new_procedure("point-in-periodic-object?-aux", point_in_periodic_objectp_aux, 2, 0, 0);
	gh_new_procedure("point-in-object?-aux", point_in_objectp_aux, 2, 0, 0);
}
