/* THIS FILE WAS AUTOMATICALLY GENERATED.  DO NOT MODIFY! */
/* generated from the file: example.scm */

#ifndef CTL_IO_H
#define CTL_IO_H

#include <guile/gh.h>
#include <ctl.h>

#ifdef __cplusplus
extern          "C" {
#endif				/* __cplusplus */

	/******* Type declarations *******/

	typedef struct material_type_struct {
		number          epsilon;
		number          conductivity;
	}               material_type;

	typedef struct geometric_object_struct {
		material_type   material;
		vector3         center;
		enum {
			GEOMETRIC_OBJECT_SELF, BLOCK, SPHERE, CYLINDER
		}               which_subclass;
		union {
			struct block_struct *block_data;
			struct sphere_struct *sphere_data;
			struct cylinder_struct *cylinder_data;
		}               subclass;
	}               geometric_object;

	typedef struct cylinder_struct {
		vector3         axis;
		number          radius;
		number          height;
		enum {
			CYLINDER_SELF, CONE
		}               which_subclass;
		union {
			struct cone_struct *cone_data;
		}               subclass;
	}               cylinder;

	typedef struct cone_struct {
		number          radius2;
	}               cone;

	typedef struct sphere_struct {
		number          radius;
	}               sphere;

	typedef struct block_struct {
		vector3         e1;
		vector3         e2;
		vector3         e3;
		vector3         size;
		matrix3x3       projection_matrix;
		enum {
			BLOCK_SELF, ELLIPSOID
		}               which_subclass;
		union {
			struct ellipsoid_struct *ellipsoid_data;
		}               subclass;
	}               block;

	typedef struct ellipsoid_struct {
		vector3         inverse_semi_axes;
	}               ellipsoid;

	typedef struct lattice_struct {
		vector3         basis1;
		vector3         basis2;
		vector3         basis3;
		vector3         size;
		vector3         basis_size;
		vector3         b1;
		vector3         b2;
		vector3         b3;
		matrix3x3       basis;
		matrix3x3       metric;
	}               lattice;

	typedef struct {
		int             num_items;
		geometric_object *items;
	}               geometric_object_list;

	typedef struct {
		int             num_items;
		vector3        *items;
	}               vector3_list;

	typedef struct {
		int             num_items;
		number         *items;
	}               number_list;

	typedef struct {
		int             num_items;
		integer        *items;
	}               integer_list;

	/******* Input variables *******/
	extern integer  dimensions;
	extern material_type default_material;
	extern lattice  geometry_lattice;
	extern geometric_object_list geometry;
	extern boolean  ensure_periodicity;
	extern vector3_list k_points;
	extern cvector3 dummy;

	/******* Output variables *******/
	extern cvector3 dummy;
	extern number   mean_dielectric;
	extern number_list gaps;

	extern int      num_read_input_vars;
	extern int      num_write_output_vars;

	extern SCM      read_input_vars(void);
	extern SCM      write_output_vars(void);
	extern SCM      destroy_input_vars(void);
	extern SCM      destroy_output_vars(void);

	/******* external-functions *******/

	extern number   function_func(function, number);
	extern SCM      function_func_aux(SCM arg_scm_0, SCM arg_scm_1);

	extern vector3_list list_func_test(number, integer_list, vector3);
	extern SCM      list_func_test_aux(SCM arg_scm_0, SCM arg_scm_1, SCM arg_scm_2);

	extern number   energy_in_object(geometric_object);
	extern SCM      energy_in_object_aux(SCM arg_scm_0);

	extern void     run_program(void);
	extern SCM      run_program_aux(void);

	extern matrix3x3 square_basis(matrix3x3, vector3);
	extern SCM      square_basis_aux(SCM arg_scm_0, SCM arg_scm_1);

	extern void     display_geometric_object_info(integer, geometric_object);
	extern SCM      display_geometric_object_info_aux(SCM arg_scm_0, SCM arg_scm_1);

	extern boolean  point_in_periodic_objectp(vector3, geometric_object);
	extern SCM      point_in_periodic_objectp_aux(SCM arg_scm_0, SCM arg_scm_1);

	extern boolean  point_in_objectp(vector3, geometric_object);
	extern SCM      point_in_objectp_aux(SCM arg_scm_0, SCM arg_scm_1);


	extern void     export_external_functions(void);

	/******* class input function prototypes *******/

	extern void     lattice_input(SCM so, lattice * o);
	extern void     ellipsoid_input(SCM so, ellipsoid * o);
	extern void     block_input(SCM so, block * o);
	extern void     sphere_input(SCM so, sphere * o);
	extern void     cone_input(SCM so, cone * o);
	extern void     cylinder_input(SCM so, cylinder * o);
	extern void     geometric_object_input(SCM so, geometric_object * o);
	extern void     material_type_input(SCM so, material_type * o);

	/******* class destruction function prototypes *******/

	extern void     lattice_destroy(lattice o);
	extern void     ellipsoid_destroy(ellipsoid o);
	extern void     block_destroy(block o);
	extern void     sphere_destroy(sphere o);
	extern void     cone_destroy(cone o);
	extern void     cylinder_destroy(cylinder o);
	extern void     geometric_object_destroy(geometric_object o);
	extern void     material_type_destroy(material_type o);


#ifdef __cplusplus
}				/* extern "C" */
#endif				/* __cplusplus */

#endif				/* CTL_IO_H */
